From: Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>
Date: Sun, 12 Sep 2021 09:22:33 +0200
Subject: power: supply: bq25890_charger: Don't enable OTG on unplugged USB

Signed-off-by: Sebastian Krzyszkowiak <sebastian.krzyszkowiak@puri.sm>
---
 drivers/power/supply/bq25890_charger.c | 33 +++++++++++++++++++--------------
 1 file changed, 19 insertions(+), 14 deletions(-)

diff --git a/drivers/power/supply/bq25890_charger.c b/drivers/power/supply/bq25890_charger.c
index 4309bad..5e33040 100644
--- a/drivers/power/supply/bq25890_charger.c
+++ b/drivers/power/supply/bq25890_charger.c
@@ -841,6 +841,20 @@ static char *bq25890_charger_supplied_to[] = {
 };
 
 
+static int bq25890_set_otg(struct bq25890_device *bq, bool otg_en)
+{
+	int ret;
+	if (bq->otg_en) {
+		dev_info(bq->dev, "%sabling OTG_EN pin\n", otg_en ? "En" : "Dis");
+		gpiod_set_value_cansleep(bq->otg_en, otg_en);
+	}
+	ret = bq25890_field_write(bq, F_OTG_CFG, otg_en);
+	if (ret < 0)
+		dev_err(bq->dev, "Failed to %sable otg: %d\n", otg_en ? "en" : "dis", ret);
+
+	return ret;
+}
+
 static void bq25890_external_power_changed(struct power_supply *psy)
 {
 	struct bq25890_device *bq = power_supply_get_drvdata(psy);
@@ -859,13 +873,7 @@ static void bq25890_external_power_changed(struct power_supply *psy)
 	}
 
 	if (supplied) {
-		if (bq->otg_en) {
-			dev_info(bq->dev, "Disabling OTG_EN pin\n");
-			gpiod_set_value_cansleep(bq->otg_en, 0);
-		}
-		ret = bq25890_field_write(bq, F_OTG_CFG, 0);
-		if (ret < 0)
-			dev_err(bq->dev, "Failed to disable otg: %d\n", ret);
+		bq25890_set_otg(bq, 0);
 
 		if (!power_supply_get_property(psy_supply, POWER_SUPPLY_PROP_CURRENT_MAX, &val))
 			max_current = val.intval / 1000;
@@ -882,13 +890,10 @@ static void bq25890_external_power_changed(struct power_supply *psy)
 		if (ret < 0)
 			dev_err(bq->dev, "Failed to set IILIM: %d\n", ret);
 	} else {
-		if (bq->otg_en) {
-			dev_info(bq->dev, "Enabling OTG_EN pin\n");
-			gpiod_set_value_cansleep(bq->otg_en, 1);
-		}
-		ret = bq25890_field_write(bq, F_OTG_CFG, 1);
-		if (ret < 0)
-			dev_err(bq->dev, "Failed to enable otg: %d\n", ret);
+		if (!power_supply_get_property(psy_supply, POWER_SUPPLY_PROP_PRESENT, &val))
+			bq25890_set_otg(bq, val.intval);
+		else
+			dev_err(bq->dev, "Failed to get supply present\n");
 	}
 
 	power_supply_changed(bq->charger);
